#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# : " "
# :      . .
# :      03.11.2013
# :    0.1
# -----------------------------------------------------------------------------

#         
use strict;

#   -     ,   -- 
#   
my %procedures = ( 1 => \&simple_regular_expressions,
                   2 => \&groupings,
                   3 => \&simple_substitutions );

while ( 1 )
{
  #    here-document -- " " (.  perlop,
  #  -- man perlop).    "<<"   
  # .   ,     
  #   .         ,
  # , EOF  FINISH,  END  . .
  print <<END_OF_MENU;
  1 --   :  
  2 --  
  3 --   
  q --   
END_OF_MENU

  my $option = <STDIN>;
  chomp $option;
  
  if ( $option eq 'q' )   #  
  {
    last;                 #    
  }
  #    -   ( )
  elsif ( exists $procedures{ $option } )
  {
    #   ,   ,   ( -
    #      ) 
    &{ $procedures{ $option } }();
  }
  else                    #    
  {
    next;                 #     --  
  }
}

exit( 0 );


# -----------------------------------------------------------------------------
#   :  
# -----------------------------------------------------------------------------
sub simple_regular_expressions
{
  my @names = qw( Andrew Eugene Paul Jonathan Caroline John Antony Natalia
                  Olivia Ophelia Roland Ronald );

  #    ,   
  # my @names = ( 'Andrew', 'Eugene', 'Paul', 'Jonathan', 'Caroline', 'John',
  #               'Antony', 'Natalia', 'Olivia', 'Ophelia', 'Roland', 
  #               'Ronald' );

  print " : ";

  #    ,   ,  
  print join( " ", sort @names );
  print "\n\n";

  print " ,    'An'\n";
  print "  -- /^An/\n";
  
  foreach my $name ( sort @names )
  {
    print "$name " if ( $name =~ /^An/ );
  }
  print "\n\n";

  # -----------------------------------

  print " ,    \n";
  #  "^"  "$" --   .    
  #       ("^")     ("$").
  #     ,    ,   , 
  #   4 , ,  --  .  [A-Z]
  #  --     A  Z, [a-z] --  , 
  # {3} --   .
  #  ,    .      
  # "\"   "$",     .
  print "  -- /^[A-Z][a-z]{3}\$/\n";
  
  foreach my $name ( sort @names )
  {
    print "$name " if ( $name =~ /^[A-Z][a-z]{3}$/ );
  }
  print "\n\n";

  # -----------------------------------

  print " ,   'ia'\n";
  print "  -- /ia\$/\n";
  
  foreach my $name ( sort @names )
  {
    print "$name " if ( $name =~ /ia$/ );
  }
  print "\n\n";

  # -----------------------------------

  print " ,   'J'    'n'\n";
  print "  -- /^J[a-z]+n\$/  /^J.+n\$/\n";
  
  foreach my $name ( sort @names )
  {
    #  "+" --  ,  --    , 
    #  .
    print "$name " if ( $name =~ /^J[a-z]+n$/ );

    #  "."   ,  . .    
    print "$name " if ( $name =~ /^J.+n$/ );
  }
  print "\n\n";

  # -----------------------------------
  
  print "  Roland  Ronald\n";
  print "  -- /^Ro(lan|nal)d\$/\n";
  
  foreach my $name ( sort @names )
  {
    #  (lan|nal)  --  :  "lan",  
    # "nal".
    print "$name " if ( $name =~ /^Ro(lan|nal)d$/ );
  }
  print "\n\n";

  return;
}

# -----------------------------------------------------------------------------
#    
# -----------------------------------------------------------------------------
sub groupings
{
  #       ,    
  # : ,    .
  my $date1 = "03-11-2013"; 
  my $date2 = "03/11/2013"; 
  my $date3 = "03.11.2013"; 

  # :     .
  
  #  ^  $ --        (   
  #  ).   , , "(\d{1,2})" -- 
  #  .      
  #       Perl   $1, $2,
  # $3  . .      -- .  ,  \d 
  #  ,  {1,2} -- , ,      
  #   .
  $date1 =~ /^(\d{1,2})-(\d{1,2})-(\d{4})$/;
  
  print " \$date1:  -- \$1,  -- \$2,  -- \$3\n";
  print " $date1:  -- $1,  -- $2,  -- $3\n";
  print "\n\n";

  #  ,      ,
  #   ,    (  [-\/\.] --
  #   ,         
  #  "\",   ,     ,  
  #   ):
  $date2 =~ /^(\d{1,2})[-\/\.](\d{1,2})[-\/\.](\d{4})$/;
  
  print " $date2:  -- $1,  -- $2,  -- $3\n";
  print "\n\n";

  # !  $1, $2  ..      
  #          .

  #       .
  my @date_elements = $date3 =~ /^(\d{1,2})[-\/\.](\d{1,2})[-\/\.](\d{4})$/;

  print " \$date3:  -- \$date_elements[ 0 ], " .
        " -- \$date_elements[ 1 ],  -- \$date_elements[ 2 ]\n";
  print " $date3:  -- $date_elements[ 0 ], " .
        " -- $date_elements[ 1 ],  -- $date_elements[ 2 ]\n";
  print "\n\n";

  #        .   
  #    :   --  
  # ,  --    .. 
  my( $day, $month, $year );
  
  ( $day, $month, $year ) = 
     $date3 =~ /^(\d{1,2})[-\/\.](\d{1,2})[-\/\.](\d{4})$/;

  print " \$date3:  -- \$day,  -- \$month,  -- \$year\n";
  print " $date3:  -- $day,  -- $month,  -- $year\n";
  print "\n\n";

  return;
}

# -----------------------------------------------------------------------------
#   
# -----------------------------------------------------------------------------
sub simple_substitutions
{
  # :     "--"  
  #         "--".
  
  my $date = "03-11-2013"; 
  my $new_date;
  
  $new_date = $date;

  #   .    -- s///.  "s"  --
  # substitute -- , .      "/",
  #     .    
  #   ,    -- - ,
  # ,       ,
  # ..    .
  $new_date =~ s/^(\d{1,2})[-\/\.](\d{1,2})[-\/\.](\d{4})$/$3-$2-$1/;
  
  print " $date,   - $new_date\n";
  print "\n\n";

  #       ,    .
  my $year = $date;
  $year =~ s/^(\d{1,2})[-\/\.](\d{1,2})[-\/\.]//;

  print " $date,  - $year\n";
  print "\n\n";

  return;
}
