#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# Группа программ: "Использование Unicode в Perl"
# Программа: работа с функциями обработки строк (русскоязычные символы)
# Автор:     Моргунов Е. П.
# Дата:      18.12.2013
# Версия:    0.1
# -----------------------------------------------------------------------------

use utf8;
binmode STDOUT, ':utf8';

my $str = "Россия";

print "Длина строки $str равна " . length( $str ) . "\n";
print "Первые три символа строки $str: " . substr( $str, 0, 3 ) . "\n";

print "\nБайтовое представление строки \"$str\"\n";

# дальнейшая работа строковых функций выполняется над БАЙТАМИ, 
# а не над СИМВОЛАМИ (символ русского алфавита в Unicode состоит из двух
# байтов)
use bytes;

for ( my $i = 0; $i < length( $str ); $i++ )
{
  # выведем значение байта в шестнадцатеричном виде
  printf( "%X ", ord substr( $str, $i, 1 ) );
}

print "\n\n";

# Это способ указания конкретного символа Unicode -- по номеру кодовой точки
# выведем русскую букву "Ё".
print "\x{0401}\n";

print "\n";

exit 0;
