#!/usr/bin/perl -w

# -----------------------------------------------------------------------------
# Группа программ: "Использование Unicode в Perl"
# Программа: использование Unicode в регулярных выражениях с русскоязычными
#            символами
# Автор:     Моргунов Е. П.
# Дата:      18.12.2013
# Версия:    0.1
# -----------------------------------------------------------------------------

use strict;

# Попробуйте закомментировать эту директиву и выполнить скрипт. Теперь
# вместо некоторых русских букв выводятся символы "?". Это объясняется
# тем, что русские буквы кодируются двумя байтами, а регулярное выражение
# без этой директивы начинает работать со строковыми литералами на уровне
# отдельных байтов, а не символов.
use utf8;

my $str = "Поиск";

# регулярное выражение позволяет записать в первую переменную -- три первых
# символа строки, а во вторую переменную -- все остальные символы
my ( $begin, $end ) = $str =~ /^(...)(.*)$/;

print "Начало: $begin\n";
print "Конец: $end\n";

# Еще один способ разделения строки на две части. Символ "?" в регулярном
# выражении означает, что квантификатор * будет "нежадным".
( $begin, $end ) = $str =~ /^(.*?[уеыаоэяию])(.*)$/;

print "Начало: $begin\n";
print "Конец: $end\n";

exit( 0 );
