#!/usr/bin/perl -w

use strict;

my( $student, $avg_mark ); # Ф. И. О. и средний балл

# Считываем файл построчно.
while ( <STDIN> )
{
  # Удалим символ новой строки.
  chomp;

  # Вычисляем средний балл для данного студента.
  # Процедура возвращает список из двух значений,
  # которые можно также присвоить списку переменных.
  ( $student, $avg_mark ) = calculate( $_ );

  print "$student $avg_mark\n";
}

exit( 0 );

sub calculate
{
  my $line = shift;  # получим значение параметра процедуры

  my @tmp;           # временный массив
  my $stud;          # фамилия, имя, отчество
  my $total = 0;     # общая сумма оценок

  # Функция split разделяет строку $line на фрагменты,
  # в качестве разделителя служат один или более пробелов.
  @tmp = split( /\s+/, $line );

  # Элементы с индексами 0, 1 и 2 -- фамилия, имя, отчество.
  # $#tmp -- это индекс последнего элемента.
  # 3 .. $#tmp -- это элементы с индексами от 3-го 
  # до последнего.
  foreach my $mark ( @tmp[ 3 .. $#tmp ] )
  {
    # print "\$mark = $mark\n";  # тестовая печать
    $total += $mark;             # суммируем оценки
  }

  $stud = "$tmp[ 0 ] $tmp[ 1 ] $tmp[ 2 ]";

  # Процедура может возвратить список значений.
  # Среднее значение вычислим, не используя
  # дополнительной переменной.
  # scalar( @tmp ) - 3 -- это число оценок.
  return ( $stud, $total / ( scalar( @tmp ) - 3 ) );
}
