#!/usr/bin/perl -w

use strict;

my $i = 0;

# Требуем два параметра командной строки. Запись $#ARGV 
# означает индекс последнего элемента массива @ARGV.
if ( $#ARGV != 1 )
{
  # Выводим сообщение об ошибке на стандартное
  # устройство ошибок.
  # Обратите внимание на отсутствие запятой после STDERR.
  print STDERR "Укажите параметры: имя входного файла " .
               "и имя результирующего\n";
  exit( 1 );    # возвращаем операционной системе значение 1
}

# Откроем файл в режиме чтения.
open( my $fread, "<", $ARGV[ 0 ] ) ||
  die "Не могу открыть файл $ARGV[ 0 ]: $!\n";

# Откроем файл в режиме записи.
open( my $fwrite, ">", $ARGV[ 1 ] ) ||
  die "Не могу открыть файл $ARGV[ 1 ]: $!\n";

# Считываем файл построчно и построчно выводим его,
# нумеруя строки.
while ( <$fread> )
{
  # Обратите внимание на отсутствие запятой
  # после переменной $fwrite.
  print $fwrite ++$i . " " . $_;
}

# Закроем файлы.
close( $fread ) ||
  die "Не могу закрыть файл $ARGV[ 0 ]: $!\n";
close( $fwrite ) ||
  die "Не могу закрыть файл $ARGV[ 1 ]: $!\n";

exit( 0 );
