#!/usr/bin/perl -w

print "Работа с файлами\n";

my $i = 0;

# переменная ARGV является массивом, хранящим параметры, переданные программе
# в командной строке. ВАЖНОЕ ОТЛИЧИЕ от языка C: имя самой программы не
# является элементом этого массива, таким образом, элемент $ARGV[ 0 ] -
# это первый параметр, $ARGV[ 1 ] - второй параметр и т.д.
if ( $#ARGV != 1 )     # требуем ДВА параметра
{
  # выводим сообщение об ошибке на стандартное устройство ошибок
  # ПРИМЕЧАНИЕ. Обратите внимание на отсутствие запятой после слова STDERR.
  print STDERR "Укажите параметры: имя входного файла и имя результирующего\n";
  exit( 1 );    # возвращаем операционной системе значение 1
}

# откроем файл в режиме чтения
# ПРИМЕЧАНИЕ. Функция open() при успешном открытии файла возвращает ненулевое
#             значение.
#             Символы "$!" означают текст сообщения об ошибке, выдаваемый
#             операционной системой. Попробуйте указать неверное имя
#             исходного файла, чтобы увидеть это сообщение.
#             Функция die аналогична функции exit(), но предварительно
#             выводит сообщение, указанное в кавычках. Операция "||" - это
#             логическое "ИЛИ". Логическое "И" обозначается "&&".
#             READ - дескриптор файла: их записывают без кавычек, как правило,
#             заглавными буквами.
#open( my $fread, "< $ARGV[ 0 ]" ) || die "Не могу открыть файл $ARGV[ 0 ]: $!\n";
my $fread;
eval { open( $fread, "<$ARGV[ 0 ]" ) || 
       die "Не могу открыть файл $ARGV[ 0 ]: $!\n";
     };
if ( $@ )
{
  print $@ . "\n";
  print "Проверка открытия файла в рамках eval\n";
  exit( 0 );
}

# откроем файл в режиме записи
# ПРИМЕЧАНИЕ. Для открытия файла в режиме дополнения вместо префикса ">"
#             нужно поставить ">>", в режиме чтения/записи "+<" или "+>>"
#open( my $fwrite, "> $ARGV[ 1 ]" ) || die "Не могу открыть файл $ARGV[ 1 ]: $!\n";
open( my $fwrite, ">", $ARGV[ 1 ] ) || die "Не могу открыть файл $ARGV[ 1 ]: $!\n";

# считываем файл построчно и построчно выводим его, нумеруя строки
while ( <$fread> )
{
  # вспомните, что означают символы "."
  # в данном случае переменная $_ "впитывает" в себя целую строку файла
  # ПРИМЕЧАНИЕ. Обратите внимание на отсутствие запятой после слова WRITE.
  print $fwrite ++$i . " " . $_;
}

# закроем фалы
close( $fread ) || die "Не могу закрыть файл $ARGV[ 0 ]: $!\n";
close( $fwrite ) || die "Не могу закрыть файл $ARGV[ 1 ]: $!\n";

exit( 0 );

