/*  6.14  :

    . ,  . '.  . 
    . . : -, 2005.
*/

/*  .  . */

/*
     -pg

  :
  ./mul_matrices size
  , 
  ./mul_matrices 500

    (     a.prof)
  
  gprof mul_matrices > a.prof
*/

#include <stdio.h>
#include <stdlib.h>


void mul_ijk( int **a, int **b, int **c, int size );
void mul_jik( int **a, int **b, int **c, int size );
void mul_jki( int **a, int **b, int **c, int size );
void mul_kji( int **a, int **b, int **c, int size );
void mul_kij( int **a, int **b, int **c, int size );
void mul_ikj( int **a, int **b, int **c, int size );

long long sum_matrix_rows( int **c, int size );
void init_c( int **c, int size );


int main( int argc, char **argv )
{
  int i;
  int j;

  int **matrix_a;
  int **matrix_b;
  int **matrix_c;
  
  /*   */
  int size = atoi( argv[ 1 ] );  /*       */

  /*    - */
  long long ijk; 
  long long jik;
  long long jki;
  long long kji; 
  long long kij;
  long long ikj;
  
  /*         . */
  matrix_a = ( int **)malloc( size * sizeof( int * ) );
  
  /*    ... */
  for ( i = 0; i < size; i++ )
  {
    /* ...  . */
    matrix_a[ i ] = ( int *)malloc( size * sizeof( int ) );
    
    /*        . */
    for ( j = 0; j < size; j++ )
    {
      matrix_a[ i ][ j ] = i;
    }
  }


  /*         . */
  matrix_b = ( int **)malloc( size * sizeof( int * ) );
  
  /*    ... */
  for ( i = 0; i < size; i++ )
  {
    /* ...  . */
    matrix_b[ i ] = ( int *)malloc( size * sizeof( int ) );
    
    /*        . */
    for ( j = 0; j < size; j++ )
    {
      matrix_b[ i ][ j ] = i;
    }
  }

  /*         . */
  matrix_c = ( int **)malloc( size * sizeof( int * ) );
  
  /*    ... */
  for ( i = 0; i < size; i++ )
  {
    /* ...  . */
    matrix_c[ i ] = ( int *)malloc( size * sizeof( int ) );
    
    /*       0. */
    for ( j = 0; j < size; j++ )
    {
      matrix_c[ i ][ j ] = 0;
    }
  }

  /*  . */
  mul_ijk( matrix_a, matrix_b, matrix_c, size );
  
  /*       . */
  ijk = sum_matrix_rows( matrix_c, size );   /*    */
  printf( "ijk = %lld\n", ijk );
  init_c( matrix_c, size );                  /*   . */

  /*  . */
  mul_jik( matrix_a, matrix_b, matrix_c, size );

  /*       . */
  jik = sum_matrix_rows( matrix_c, size );
  printf( "jik = %lld\n", jik );
  init_c( matrix_c, size );

  /*  -- . */
  mul_jki( matrix_a, matrix_b, matrix_c, size );
  jki = sum_matrix_rows( matrix_c, size );
  printf( "jki = %lld\n", jki );
  init_c( matrix_c, size );

  mul_kji( matrix_a, matrix_b, matrix_c, size );
  kji = sum_matrix_rows( matrix_c, size );
  printf( "kji = %lld\n", kji );
  init_c( matrix_c, size );

  mul_kij( matrix_a, matrix_b, matrix_c, size );
  kij = sum_matrix_rows( matrix_c, size );
  printf( "kij = %lld\n", kij );
  init_c( matrix_c, size );

  mul_ikj( matrix_a, matrix_b, matrix_c, size );
  ikj = sum_matrix_rows( matrix_c, size );
  printf( "ikj = %lld\n", ikj );
  /* init_c( c, size ); */

  return 0;
}


void mul_ijk( int **a, int **b, int **c, int size )
{
  int i;
  int j;
  int k;
  int sum;

  for ( i = 0; i < size; i++ )
  {
    for ( j = 0; j < size; j++ )
    {
      sum = 0;
      for ( k = 0; k < size; k++ )
      {
        sum += a[ i ][ k ] * b[ k ][ j ];
      }
      c[ i ][ j ] += sum;
    }
  }

  return;
}

void mul_jik( int **a, int **b, int **c, int size )
{
  int i;
  int j;
  int k;
  int sum;

  for ( j = 0; j < size; j++ )
  {
    for ( i = 0; i < size; i++ )
    {
      sum = 0;
      for ( k = 0; k < size; k++ )
      {
        sum += a[ i ][ k ] * b[ k ][ j ];
      }
      c[ i ][ j ] += sum;
    }
  }

  return;
}

void mul_jki( int **a, int **b, int **c, int size )
{
  int i;
  int j;
  int k;
  int r;
  
  for ( j = 0; j < size; j++ )
  {
    for ( k = 0; k < size; k++ )
    {
      r = b[ k ][ j ];
      for ( i = 0; i < size; i++ )
      {
        c[ i ][ j ] += a[ i ][ k ] * r;
      }
    }
  }

  return;
}

void mul_kji( int **a, int **b, int **c, int size )
{
  int i;
  int j;
  int k;
  int r;
  
  for ( k = 0; k < size; k++ )
  {
    for ( j = 0; j < size; j++ )
    {
      r = b[ k ][ j ];
      for ( i = 0; i < size; i++ )
      {
        c[ i ][ j ] += a[ i ][ k ] * r;
      }
    }
  }

  return;
}

void mul_kij( int **a, int **b, int **c, int size )
{
  int i;
  int j;
  int k;
  int r;
  
  for ( k = 0; k < size; k++ )
  {
    for ( i = 0; i < size; i++ )
    {
      r = a[ i ][ k ];
      for ( j = 0; j < size; j++ )
      {
        c[ i ][ j ] += r * b[ k ][ j ];
      }
    }
  }

  return;
}

void mul_ikj( int **a, int **b, int **c, int size )
{
  int i;
  int j;
  int k;
  int r;
  
  for ( i = 0; i < size; i++ )
  {
    for ( k = 0; k < size; k++ )
    {
      r = a[ i ][ k ];
      for ( j = 0; j < size; j++ )
      {
        c[ i ][ j ] += r * b[ k ][ j ];
      }
    }
  }

  return;
}

void init_c( int **matrix_c, int size )
{
  int i;
  int j;
  
  /*    ... */
  for ( i = 0; i < size; i++ )
  {
    /* ...       0. */
    for ( j = 0; j < size; j++ )
    {
      matrix_c[ i ][ j ] = 0;
    }
  }
  return;
}

long long sum_matrix_rows( int **matrix_c, int size )
{
  int i;
  int j;
  long long sum = 0;

  for ( i = 0; i < size; i++ )
  {
    for ( j = 0; j < size; j++ )
    {
      /*     . */
      sum += matrix_c[ i ][ j ];
    }
  }

  return sum;
}
