/* ----------------------------------------------------------------------------
   ,    
    .
---------------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>

/*        , . .  
        .
   #include "geometry.h" */

/*    ,   
       float
   (     ). */
typedef float ( *library_func )( float );

/*   get_func() */
library_func get_func( void *lib_handle, const char *func_name );

int main( void )
{
  float rad;
  float side;

  void *lib;             /*    */
  library_func lib_fn;   /*      */
  const char *error;     /*        */
  
  /*   .
     .        
                 libgeometry.so,   libgeometry.so.2, 
                 libgeometry.so.2.0.1,  libgeometry.so.2.1.1.
                    libgeometry.so.1,    .
                     .
                       ,  
                     
                 . */
  lib = dlopen( "libgeometry.so", RTLD_LAZY );

  if ( !lib )
  {
    fprintf( stderr, "    libgeometry.so: %s\n",
             dlerror() );
    exit( 1 );
  }                 

  /* DEBUG */
  /* dlsym( lib, "nonexistent_function" );
     dlsym( lib, "circle_len" );
     if ( error = dlerror() )
       fprintf( stderr, ": %s\n", error );
    
     fprintf( stderr, ": %s\n", dlerror() );
  */
  
  printf( "   \n\n" );

  printf( "  : " );
  scanf( "%f", &rad );
  printf( "\n%f\n", rad );

  /*       circle_len,
       .
     .   ,    . */
  if ( ( lib_fn = get_func( lib, "circle_len" ) ) != NULL )
    printf( " : %f\n", ( *lib_fn )( rad ) );
  
  /*        . */
  if ( ( lib_fn = get_func( lib, "circle_area" ) ) != NULL )
    printf( " : %f\n", ( *lib_fn )( rad ) );

  printf( "\n   : " );
  scanf( "%f", &side );
  printf( "\n%f\n", side );

  if ( ( lib_fn = get_func( lib, "square_perim" ) ) != NULL )
    printf( " : %f\n", ( *lib_fn )( side ) );

  if ( ( lib_fn = get_func( lib, "square_area" ) ) != NULL )
    printf( " : %f\n", ( *lib_fn )( side ) );
  
  /*  . */
  dlclose( lib );

  return 0;
}

library_func get_func( void *lib_handle, const char *func_name )
{
  /* lib_handle -    */
  /* func_name -     */

  library_func lib_func; /*      */
  const char *error;

  /*   ,      ""
       . */
  /* . .     DEBUG
                   main().   ,
                    ,  . */
  dlerror();

  /*     . */
  lib_func = dlsym( lib_handle, func_name );

  /*  ,     ,
         . */
  if ( error = dlerror() )
  {
    fprintf( stderr, "   %s: %s\n", func_name, error );

    /*       . */
    /* exit( 1 ); */

    return NULL;
  }

  return lib_func;
}
