#!/usr/bin/perl -w
# ----------------------------------------------------------------------------
# Программа, использующая функции из модуля Perl
# ----------------------------------------------------------------------------

# такая директива позволяет импортировать только те функции,
# которые включены в массив @EXPORT модуля Math::Geometry
# (в данном случае нас интересуют функции circle_len и circle_area)
use Math::Geometry;

# такая директива позволяет импортировать те функции,
# которые включены в массив @EXPORT_OK модуля Math::Geometry
# ПРИМЕЧАНИЕ. Для включения в список двух и более функций
#             просто разместите их внутри скобок, разделяя пробелами.
use Math::Geometry qw( square_perim );

# аналог директивы препроцессора #define
use constant  PRINT_FORMULA => 1;

use strict;

my $rad;
my $side;

print "Тестирование модуля (пакета) Math::Geometry\n\n";

print "Введите радиус окружности: ";
$rad = <STDIN>;
printf "\n%f\n", $rad;
printf "Длина окружности: %f\n", circle_len( $rad, PRINT_FORMULA );
printf "Площадь круга: %f\n", circle_area( $rad, PRINT_FORMULA );

print "\nВведите длину стороны квадрата: ";
$side = <STDIN>;
printf "\n%f\n", $side;
printf "Периметр квадрата: %f\n", square_perim( $side, PRINT_FORMULA );

# поскольку функция square_area не включена ни в массив @EXPORT, 
# ни в массив @EXPORT_OK модуля (пакета) Math::Geometry,
# то приходится вызывать ее с полным именем,
# включающим имя модуля (пакета)
printf "Площадь квадрата: %f\n",
       Math::Geometry::square_area( $side, PRINT_FORMULA );

print "\nПеременные пакета Math::Geometry\n";
# ПРИМЕЧАНИЕ. Обратите внимание, что значение переменной priv_var пустое,
#             и при этом выводится предупредительное сообщение.
print "priv_var = " . $Math::Geometry::priv_var . "\n";
print "Var1 = " . $Math::Geometry::Var1 . "\n";
print "stuff = " . $Math::Geometry::stuff . "\n";

exit 0;
