/*
 * : test2.c
 *          libpq.
 *     :   ,  
 *        ,   
 *   ,   .   -- students,
 *  -- progress.     .  
 * test_db.sql.      : 
 *
 * psql -f test_db.sql -U postgres
 */

/*
  .         
   .  printf()    ,
     UTF-8,    Debian,   
    . ,        
   ,   --  .     
  ?   . ,      printf() 
   "%-30s",        (  
    "-")     30 .  
   ""   progress  :   ""
  6   ,  . 12 .  12   
     30 , . .  18 . 
       6 + 18 = 24 ,  "" - 
  12 + 18 = 30 .   "" : 10 * 2 = 20 
   ,    30   printf()
   10 ,         
  20 ,  ,      "". ?
    .      students    
  .     " "  " "
   .
     ,     ,  ,   
    ,   .   
    prg18.c       C
  (http://www.morgunov.org/teaching.html).    
     Unicode    ,  ,
   ,     PostgreSQL  libpq   :
         ,   
         
    .
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "libpq-fe.h"

static void exit_nicely( PGconn *conn )
{
  PQfinish( conn );
  exit( 1 );
}

int main( int argc, char **argv )
{
  const char *conninfo; /*       */
  PGconn     *conn;     /*      */
  PGresult   *res_s;    /*   SQL-  . students */
  PGresult   *res_p;    /*   SQL-  . progress */ 
  int        nFields_s; /*      . students */
  int        nFields_p; /*      . progress */

  /*        */
  int        i, j;      /* students */ 
  int        k, l;      /* progress */

  /*     . progress */
  char command_p[ 256 ];

  /*
   *       ,
   *        conninfo;
   *       ,   
   *       
   * "dbname=test user=postgres"
  */
  if ( argc > 1 )
    conninfo = argv[ 1 ];
  else
    conninfo = "dbname=test user=postgres";

  /*    . */
  conn = PQconnectdb( conninfo );

  /*   . */
  if ( PQstatus( conn ) != CONNECTION_OK )
  {
    fprintf( stderr, "     : %s",
             PQerrorMessage( conn ) );
    exit_nicely( conn );
  }

  /*  PQexec  SQL-,  
        . */
  res_s = PQexec( conn, "SELECT * FROM students" );

  if ( PQresultStatus( res_s ) != PGRES_TUPLES_OK)
  {
    fprintf( stderr, " SELECT   students : %s",
             PQerrorMessage( conn ) );
    PQclear( res_s );
    exit_nicely( conn );
  }

  nFields_s = PQnfields( res_s );  /*     */
  
  /*        
     (     students). */
  for ( j = 0; j < nFields_s; j++ )
  {
    /*   ", , "   
       ( PQfname      
         ). */
    if ( strcmp( PQfname( res_s, j ), "name" ) == 0 )
      printf( "%-40s", PQfname( res_s, j ) );
    else
      printf( "%-12s", PQfname( res_s, j ) );
  }

  printf( "\n\n" );

  /*     
     ( PQntuples     ). */
  for ( i = 0; i < PQntuples( res_s ); i++ )
  {
    for ( j = 0; j < nFields_s; j++ )
    {
      if ( strcmp( PQfname( res_s, j ), "name" ) == 0 )
        /*  PQgetvalue     i
              j. */
        printf( "%-40s", PQgetvalue( res_s, i, j ) );
      else
        printf( "%-12s", PQgetvalue( res_s, i, j ) );
    }
    printf( "\n" );

    /*   record_book     ,  
         students.       
            progress.    
        progress   ,     
       record_book ( )  ,      
         students.       
       sprintf()  %s,   %d,   PQgetvalue()
            .  PQfnumber()
            . */
    sprintf( command_p, "SELECT * FROM progress WHERE record_book = %s",
             PQgetvalue( res_s, i, PQfnumber( res_s, "record_book" ) ) );

    res_p = PQexec( conn, command_p );

    if ( PQresultStatus( res_p ) != PGRES_TUPLES_OK )
    {
      fprintf( stderr, " SELECT   progress : %s",
               PQerrorMessage( conn ) );
      /*  ,     PGresult,
                 students,
           -- progress. */
      PQclear( res_s );
      PQclear( res_p );
      exit_nicely( conn );
    }

    /*       progress */
    nFields_p = PQnfields( res_p );

    /*     
       ( PQntuples     ). */
    for ( k = 0; k < PQntuples( res_p ); k++ )
    {
      /*     progress   
           (     ). */
      printf( "    " );

      /*     ()   progress. */
      for ( l = 0; l < nFields_p; l++ )
      {
        /*   " "    . */
        if ( strcmp( PQfname( res_p, l ), "subject" ) == 0 )
          /*  PQgetvalue     l
                k. */
          printf( "%-30s", PQgetvalue( res_p, k, l ) );
        else
          printf( "%-10s", PQgetvalue( res_p, k, l ) );
      }
      printf( "\n" );
    }

    printf( "\n" );
    PQclear( res_p );
  }

  /*  ,    res_s,
           . */
  PQclear( res_s );

  /*     . */
  PQfinish( conn );

  return 0;
}
