/*
 * : test3.c
 *     ,    .
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "libpq-fe.h"

static void exit_nicely( PGconn *conn )
{
  PQfinish( conn );
  exit( 1 );
}

int main( int argc, char **argv )
{
  const char *conninfo;   /*       */
  PGconn     *conn;       /*      */
  PGresult   *res;        /*   SQL- */
  int        nFields;     /*     */
  int        i, j;

  char command[ 512 ];    /*    SQL-, */
  char record_book[ 6 ];  /*       */
  char name[ 50 ];        /*    ... */
  char psp_ser[ 5 ];      /*      */
  char psp_num[ 7 ];      /*       */

  /*     SQL- */

  printf( "   : " );
  scanf( "%s", record_book );    

  /*   ,       '\n'. */
  scanf( "%*[^\n]" );  /*       '\n'. */
  scanf( "%*c" );      /*   '\n'. */

  printf( " ...: " );
  fgets( name, 49, stdin );

  /*    fgets()      '\n', 
         Enter,     
      '\0',   . */
  name[ strlen( name ) - 1 ] = '\0';

  printf( "  : " );
  scanf( "%s",  psp_ser );
  printf( "  : " );
  scanf( "%s",  psp_num );

  /*   SQL-. */

  sprintf( command,
          "INSERT INTO students ( record_book, name, psp_ser, psp_num ) "\
          "VALUES ( %s, '%s', %s, %s )",
          record_book, name, psp_ser, psp_num );

  if ( argc > 1 )
    conninfo = argv[ 1 ];
  else
    conninfo = "dbname=test user=postgres";

  /*    . */
  conn = PQconnectdb( conninfo );

  /*   . */
  if ( PQstatus( conn ) != CONNECTION_OK )
  {
    fprintf( stderr, "     : %s",
             PQerrorMessage( conn ) );
    exit_nicely( conn );
  }

  /*  PQexec  SQL-,  
        . */
  res = PQexec( conn, command );

  /*   -- PGRES_COMMAND_OK --  ,  ,
        , . . INSERT, UPDATE, DELETE. */
  if ( PQresultStatus( res ) != PGRES_COMMAND_OK )
  {
    fprintf( stderr, " INSERT : %s",
             PQerrorMessage( conn ) );
    PQclear( res );
    exit_nicely( conn );
  }
  else
  {
    printf("    students."); 
  }

  /*  ,    res,
           . */
  PQclear( res );

  /*     . */
  PQfinish( conn );

  return 0;
}
