-- --------------------------------------------------------------------------
--  :       
--  :   . . 
--  :    30.11.2017
--  :  0.1
-- --------------------------------------------------------------------------

--       :

-- psql -f test_db.sql -U postgres

DROP DATABASE IF EXISTS test;
CREATE DATABASE test;
\connect test

-- ---------------------------------------------------------------------------
--  ""
-- ---------------------------------------------------------------------------
CREATE TABLE students
( record_book numeric( 5 ) NOT NULL,  --   
  name text NOT NULL,                 -- . . . 
  psp_ser numeric( 4 ),               --  
  psp_num numeric( 6 ),               --  
  PRIMARY KEY ( record_book )
);

INSERT INTO students ( record_book, name, psp_ser, psp_num )
       VALUES ( 12300, '  ', 0402, 543281 );
INSERT INTO students ( record_book, name, psp_ser, psp_num )
       VALUES ( 12700, '  ', 0204, 123281 );
INSERT INTO students ( record_book, name, psp_ser, psp_num )
       VALUES ( 12900, '  ', 0304, 224287 );


-- ---------------------------------------------------------------------------
--  ""
-- ---------------------------------------------------------------------------
CREATE TABLE progress
( record_book numeric( 5 ) NOT NULL,   --   
  subject text NOT NULL,               --  
  acad_year text NOT NULL,             --  
  term numeric( 1 ) NOT NULL           -- 
    CHECK ( term = 1 or term = 2 ),
  mark numeric( 1 ) NOT NULL           -- 
    CHECK ( mark >= 3 and mark <= 5 )
    DEFAULT 5,
  FOREIGN KEY ( record_book )
    REFERENCES students ( record_book )
    ON DELETE CASCADE
    ON UPDATE CASCADE
);


INSERT INTO progress VALUES ( 12300, '', '2017/2018', 1, 4 );
INSERT INTO progress VALUES ( 12300, '', '2017/2018', 1, 5 );
INSERT INTO progress VALUES ( 12700, '', '2016/2017', 2, 3 );
INSERT INTO progress VALUES ( 12700, '', '2016/2017', 2, 5 );
INSERT INTO progress VALUES ( 12900, '', '2017/2018', 1, 4 );
INSERT INTO progress VALUES ( 12900, '', '2016/2017', 2, 4 );
INSERT INTO progress VALUES ( 12900, '', '2016/2017', 2, 4 );
