#!/usr/bin/perl -w
# ----------------------------------------------------------------------------
#  test_pq.pl.
#         DBI  DBD::Pg.
# ----------------------------------------------------------------------------

#       
#  .
use strict;

#   ,      
#  Unicode   UTF-8 (    ).
#  if ,    utf8  ,
#    -- Lnux.
use if ( $^O eq 'linux' ), "utf8";

#       decode().
use if ( $^O eq 'linux' ), "Encode";

#      .
use DBI;

#    .
use constant DBNAME => 'test';   #   

#     UTF-8   STDERR ( 
#     ), . .  die() 
#   STDERR (. perldoc -f die).
#    .   
# "Wide character in die at ...".
# .     (     ):
#             binmode STDOUT, ':utf8';
binmode STDERR, ':encoding(UTF-8)';

#          UTF-8.
#    ,     print 
#   "Wide character in print ...".
binmode STDOUT, ':encoding(UTF-8)';

#        
#   .    ?
binmode STDIN, ':encoding(UTF-8)';

my $conn;     #    
my $rc;       #   SQL-
my $row;      #   -      
my $command;  #  SQL-    
my $sth;      #     
my $num_recs; #  ,    Students
my $err_flag; #      

#      .
#   : RaiseError => 0 --   
#       ; AutoCommit => 1 --
#       ,  
#      ; PrintError => 0 --  
#    .
#   RaiseError   1,    
#    :     
#  .
$conn = DBI->connect( "dbi:Pg:dbname=" . DBNAME, 'postgres', '',
                      { RaiseError => 0, AutoCommit => 1,
                        PrintError => 0 } );

#   .
die "      " . DBNAME . ": " . 
    ( $^O eq 'linux' ) ? decode( 'UTF-8', $DBI::errstr ) : $DBI::errstr 
    unless defined $conn;

#       Students.
#         
#    . 
# .       
#                  or (
#              !).
$rc = $conn->begin_work or
die "   : " . $DBI::errstr;

#  SQL-    .
#  "?" (placeholders)   ,
#      execute.
$command = "INSERT INTO students " .
           "( record_book, name, psp_ser, psp_num ) " .
           "VALUES ( ?, ?, ?, ? )";

#  (prepare)      .  
#    ,    .
#      .
$sth = $conn->prepare( $command ) or
die "   : " . $DBI::errstr;

print "      ,\n";
print "   :\n";
print "   . . .    \n";
print ":\n";
print "12345    0205 123098\n";
print "        Enter\n";

$num_recs = 0;
$err_flag = 0;

#     .
while ( <STDIN> )
{
  chomp;
  last if /^$/;  #    --   .

  #      .  
  my @values = split( /\s+/ );
  
  #     .
  #         ,
  #          die,
  #        .
  $rc = $sth->execute( $values[ 0 ],
                       "$values[ 1 ] $values[ 2 ] $values[ 3 ]",
                       $values[ 4 ], $values[ 5 ] );

  if ( defined $rc )  #   .
  {
    $num_recs++;
    print "    Students\n";
    print "       Enter\n";
  }
  else
  {
    #          $DBI->errstr,
    #       $sth.  state  
    # .     SQL.
    print "      Students\n";
    print " ( PostgreSQL): " . $sth->state . "\n";
    print $sth->errstr . "\n\n";
    $err_flag = 1;
    last;
  }
}

#            
#  .
if ( $num_recs > 0 && ! $err_flag )
{
  print "     (y/n)?\n";

  my $save = <STDIN>;
  chomp $save;

  if ( $save eq 'y' )
  {
    #     .
    $rc = $conn->commit or
    die "   : " . $DBI::errstr;
  }
  else
  {
    print " \n\n";
    $rc = $conn->rollback or 
    die "   : " . $DBI::errstr;
  }
}
#          .
else
{
  print " \n\n";
  $rc = $conn->rollback or 
  die "   : " . $DBI::errstr;
}

#      Students,    
#  name.  SQL-    .
$command = "SELECT * FROM students ORDER BY name";

#  .
$sth = $conn->prepare( $command ) or
die "   : " . $DBI::errstr;

#     .
$rc = $sth->execute or
die "   : " . $DBI::errstr;

#       ,  .
if ( $sth->rows == 0 )
{
  print "  Students  \n";

  #     .
  $conn->disconnect or
  die "    : " . $DBI::errstr;

  exit ( 0 );
}

#   .
printf "%-12s", ". ";
printf "%-30s", ". . .";
printf "%-12s", " .";
printf "%-12s", " .";
print "\n\n";

#      .
#  fetchrow_hashref   -  
#        -.
while ( $row = $sth->fetchrow_hashref )
{
  #  NULL,      ,
  #   Perl    undef.   
  #      undef  .
  foreach ( keys %{ $row } )
  {
    $row->{ $_ } = '' unless defined $row->{ $_ };
  }

  #   -,     
  #  ()  Students.
  printf "%-12s", $row->{ 'record_book' };
  printf "%-30s", $row->{ 'name' };
  printf "%-12s", $row->{ 'psp_ser' };
  printf "%-12s", $row->{ 'psp_num' };
  print "\n";
}

#     .
$conn->disconnect or
die "    : " . $DBI::errstr;

exit ( 0 );
