-- --------------------------------------------------------------------------
--  Модуль:  команды для создания таблиц базы данных
--  Автор:   Е. П. Моргунов
--  Дата:    30.11.2017
--  Версия:  0.1
-- --------------------------------------------------------------------------

-- Для создания базы данных нужно выполнить команду:

-- psql -f test_db.sql -U postgres

DROP DATABASE IF EXISTS test;
CREATE DATABASE test;
\connect test

-- ---------------------------------------------------------------------------
-- Таблица "Студенты"
-- ---------------------------------------------------------------------------
CREATE TABLE students
( record_book numeric( 5 ) NOT NULL,  -- номер зачетной книжки
  name text NOT NULL,                 -- Ф. И. О. студента
  psp_ser numeric( 4 ),               -- серия паспорта
  psp_num numeric( 6 ),               -- номер паспорта
  PRIMARY KEY ( record_book )
);

INSERT INTO students ( record_book, name, psp_ser, psp_num )
       VALUES ( 12300, 'Иванов Иван Иванович', 0402, 543281 );
INSERT INTO students ( record_book, name, psp_ser, psp_num )
       VALUES ( 12700, 'Климов Андрей Николаевич', 0204, 123281 );
INSERT INTO students ( record_book, name, psp_ser, psp_num )
       VALUES ( 12900, 'Петров Петр Петрович', 0304, 224287 );


-- ---------------------------------------------------------------------------
-- Таблица "Успеваемость"
-- ---------------------------------------------------------------------------
CREATE TABLE progress
( record_book numeric( 5 ) NOT NULL,   -- номер зачетной книжки
  subject text NOT NULL,               -- учебная дисциплина
  acad_year text NOT NULL,             -- учебный год
  term numeric( 1 ) NOT NULL           -- семестр
    CHECK ( term = 1 or term = 2 ),
  mark numeric( 1 ) NOT NULL           -- оценка
    CHECK ( mark >= 3 and mark <= 5 )
    DEFAULT 5,
  FOREIGN KEY ( record_book )
    REFERENCES students ( record_book )
    ON DELETE CASCADE
    ON UPDATE CASCADE
);


INSERT INTO progress VALUES ( 12300, 'Физика', '2017/2018', 1, 4 );
INSERT INTO progress VALUES ( 12300, 'Математика', '2017/2018', 1, 5 );
INSERT INTO progress VALUES ( 12700, 'Физика', '2016/2017', 2, 3 );
INSERT INTO progress VALUES ( 12700, 'Программирование', '2016/2017', 2, 5 );
INSERT INTO progress VALUES ( 12900, 'Математика', '2017/2018', 1, 4 );
INSERT INTO progress VALUES ( 12900, 'Физика', '2016/2017', 2, 4 );
INSERT INTO progress VALUES ( 12900, 'Программирование', '2016/2017', 2, 4 );
