<?php
/*
  : "  "
  :      (    
             )
  :   . . 
  :    30.11.2017
  :  0.1
*/

//          
// .
define( "CONNECTION_STRING", "host=localhost dbname=edu user=postgres" );

//      ,  ,
//         .
// $log = fopen( 'log.txt', 'a' );
// fwrite( $log, "insert_discipline\n" );
// fclose( $log );

/*
       disciplines.
*/
function delete_discipline( $discipline_code )
{
  // : $discipline_code --   .

  //    .
  $dbconn = pg_connect( CONNECTION_STRING )
    or die( '     : ' . pg_last_error() );

  //  ,      
  // -: $1, $2  . .
  $query = "DELETE FROM disciplines WHERE discipline_code = $1";

  //     .    
  //   .
  $result = pg_query_params( $dbconn, $query, array( $discipline_code ) );

  // .      SQLSTATE,  
  //                ,   
  //              :
  // pg_send_query_params( $dbconn, $query, array( $discipline_code ) );
  //                 :
  // $result = pg_get_result( $dbconn );

  //    .
  if ( pg_result_status( $result ) != PGSQL_COMMAND_OK )
  {
    //        .  
    //  web-      delete_record
    // (.  university.js).
    echo pg_last_error( $dbconn );

    // .         
    //                  SQLSTATE,  
    //                 :
    // echo pg_result_error_field( $result, PGSQL_DIAG_SQLSTATE );
    //                   :
    // pg_free_result( $result );

    //      .
    pg_close( $dbconn );

    return;
  }

  //   JSON.   rows    
  //   (1  0).   JSON   .
  //   web-     delete_record,
  //    JavaScript (.  university.js).  
  //    delete_discipline    ""
  // (.  display_disciplines_list   disciplines_view.php).
  echo '{ "rows": "' . pg_affected_rows( $result ) . '" }';
  
  //  .
  pg_free_result( $result );

  //      .
  pg_close( $dbconn );
}


/*
       disciplines.
*/
function get_discipline_info( $discipline_code )
{
  // : $discipline_code --   .
  
  $dbconn = pg_connect( CONNECTION_STRING ) or
    die( '     : ' . pg_last_error() );

  //     .
  $query = "SELECT discipline_code, discipline_name " .
           "FROM disciplines WHERE discipline_code = $1";

  $result = pg_query_params( $dbconn, $query, array( $discipline_code ) );

  //  ,    PGSQL_TUPLES_OK,
  //   PGSQL_COMMAND_OK.
  if ( pg_result_status( $result ) != PGSQL_TUPLES_OK )
  {
    die ( ': ' . pg_last_error( $dbconn ) );
  }

  //     --    .
  $discipline_info = pg_fetch_array( $result, NULL, PGSQL_ASSOC );
  
  pg_free_result( $result );
  pg_close( $dbconn );

  return $discipline_info;
}

/*
       disciplines.
*/
function get_disciplines_list()
{
  $disciplines_list = array();

  $dbconn = pg_connect( CONNECTION_STRING ) or
    die( '     : ' . pg_last_error() );

  $query = 'SELECT discipline_code, discipline_name ' .
           'FROM disciplines ORDER BY discipline_name';

  //   WHERE   ,   pg_query.
  $result = pg_query( $dbconn, $query );

  //  ,    PGSQL_TUPLES_OK,
  //   PGSQL_COMMAND_OK.
  if ( pg_result_status( $result ) != PGSQL_TUPLES_OK )
  {
    die ( ': ' . pg_last_error( $dbconn ) );
  }

  //          .
  //  NULL ,      .
  //  PGSQL_ASSOC ,      
  //   - ( ).
  while ( $discipline_info = pg_fetch_array( $result, NULL, PGSQL_ASSOC ) )
  {
    //   (  ) , 
    //        .
    //   ,  $discipline_info --  
    //  ().
    $disciplines_list[] = $discipline_info;
  }

  pg_free_result( $result );
  pg_close( $dbconn );

  return $disciplines_list;
}

/*
       disciplines.
*/
function insert_discipline()
{
  //    .
  $dbconn = pg_connect( CONNECTION_STRING )
    or die( '     : ' . pg_last_error() );

  //  ,      
  // -: $1, $2  . .
  $query = "INSERT INTO disciplines ( discipline_code, discipline_name ) " .
           "VALUES ( $1, $2 )";

  //     .    
  //   .
  $result = pg_query_params( $dbconn, $query,
                             array( $_POST[ 'discipline_code' ],
                                    $_POST[ 'discipline_name' ]
                                  )
                           );

  //    .
  if ( pg_result_status( $result ) != PGSQL_COMMAND_OK )
  {
    die ( ': ' . pg_last_error( $dbconn ) );
  }

  //     (1  0).
  $num_rows = pg_affected_rows( $result );
  
  //  .
  pg_free_result( $result );

  //      .
  pg_close( $dbconn );

  return $num_rows;
}

/*
       disciplines.
*/
function update_discipline()
{
  $dbconn = pg_connect( CONNECTION_STRING )
    or die( '     : ' . pg_last_error() );

  $query = "UPDATE disciplines " .
           "SET ( discipline_code, discipline_name ) = " .
           "( $1, $2 ) " .
           "WHERE discipline_code = $3";

  $result = pg_query_params( $dbconn, $query,
                             array( $_POST[ 'discipline_code' ],
                                    $_POST[ 'discipline_name' ],
                                    $_POST[ 'current_discipline_code' ] )
                           );

  if ( pg_result_status( $result ) != PGSQL_COMMAND_OK )
  {
    die ( ': ' . pg_last_error( $dbconn ) );
  }

  //     (1  0).
  $num_rows = pg_affected_rows( $result );

  pg_free_result( $result );
  pg_close( $dbconn );

  return $num_rows;
}

?>
