-- ---------------------------------------------------------------------------
--  : "  "
--  :       
--  :   . . 
--  :    30.11.2017
--  :  0.1
-- ---------------------------------------------------------------------------

--       :

-- psql -f edu_db.sql -U postgres

DROP DATABASE IF EXISTS edu;
CREATE DATABASE edu;
\connect edu

-- ---------------------------------------------------------------------------
--  ""
-- ---------------------------------------------------------------------------
CREATE TABLE students
( record_book numeric( 5, 0 ) NOT NULL, --   
  name text NOT NULL,                   -- . . . 
  psp_ser numeric( 4, 0 ),              --  
  psp_num numeric( 6, 0 ),              --  
  PRIMARY KEY ( record_book )
);

-- ---------------------------------------------------------------------------
--  " "
-- ---------------------------------------------------------------------------
CREATE TABLE disciplines
( discipline_code smallint NOT NULL,    --  
  discipline_name text NOT NULL,        --  
  CHECK ( discipline_code > 0 ),
  UNIQUE ( discipline_name ),
  PRIMARY KEY ( discipline_code )
);

-- ---------------------------------------------------------------------------
--  " "
-- ---------------------------------------------------------------------------
CREATE TABLE progress
( record_book numeric( 5, 0 ) NOT NULL, --   
  acad_year text NOT NULL,              --  
  term numeric( 1, 0 ) NOT NULL,        -- 
  discipline_code smallint NOT NULL,    --  
  mark numeric( 1, 0 ),                 -- 
  CHECK ( mark >= 3 AND mark <= 5 ),
  CHECK ( term = 1 OR term = 2 ),
  PRIMARY KEY ( record_book, acad_year, term, discipline_code ),
  FOREIGN KEY ( discipline_code )
    REFERENCES disciplines ( discipline_code )
    ON UPDATE CASCADE,
  FOREIGN KEY ( record_book )
    REFERENCES students ( record_book )
    ON UPDATE CASCADE
    ON DELETE CASCADE
);

INSERT INTO students ( record_book, name, psp_ser, psp_num )
VALUES ( 11111, '  ', 1111, 111111 ),
       ( 22222, '  ', 2222, 222222 ),
       ( 33333, '  ', 3333, 333333 ),
       ( 44444, '  ', 4444, 444444 ),
       ( 55555, '  ', 5555, 555555 );

INSERT INTO disciplines ( discipline_code, discipline_name )
VALUES ( 1, ' ' ),
       ( 2, ' ' ),
       ( 3, '  ' ),
       ( 4, ' ' ),
       ( 5, '' );

INSERT INTO progress ( record_book, acad_year, term, discipline_code, mark )
VALUES ( 11111, '2017/2018', 1, 1, 5 ),
       ( 11111, '2017/2018', 2, 2, 3 ),
       ( 22222, '2015/2016', 1, 5, 4 ),
       ( 33333, '2017/2018', 1, 4, 4 ),
       ( 33333, '2016/2017', 2, 5, 5 ),
       ( 33333, '2017/2018', 2, 4, 5 ),
       ( 44444, '2017/2018', 1, 1, 4 ),
       ( 44444, '2016/2017', 2, 3, 5 ),
       ( 44444, '2016/2017', 2, 2, 5 ),
       ( 55555, '2016/2017', 1, 4, 5 ),
       ( 55555, '2017/2018', 2, 2, 3 );
