<?php
/*
  : "  "
  :  " " (   )
  :   . . 
  :    30.11.2017
  :  0.1
*/

//          
// .
define( "CONNECTION_STRING", "host=localhost dbname=edu user=postgres" );

//      ,  ,
//         .
// $log = fopen( 'log.txt', 'a' );
// fwrite( $log, "insert_exam " . $record_book . "\n" );
// fclose( $log );

/*
       progress.
*/
function delete_exam( $record_book, $acad_year, $term, $discipline_code )
{
  // : $record_book --   ;
  //            $aad_year --  ;
  //            $term -- ;
  //            $dscipline_code --   .

  //    .
  $dbconn = pg_connect( CONNECTION_STRING )
    or die( '     : ' . pg_last_error() );

  //  ,      
  // -: $1, $2  . .
  $query = "DELETE FROM progress " .
           "WHERE record_book = $1 AND acad_year = $2 AND " .
                 "term = $3 AND discipline_code = $4" ;

  //     .    
  //   .
  $result = pg_query_params( $dbconn, $query,
                             array( $record_book, $acad_year, $term,
                                    $discipline_code )
                           );

  //    .
  if ( pg_result_status( $result ) != PGSQL_COMMAND_OK )
  {
    //        .  
    //  web-      delete_record
    // (.  university.js).
    echo pg_last_error( $dbconn );

    //      .
    pg_close( $dbconn );

    return;
  }

  //   JSON.   rows    
  //   (1  0).   JSON   .
  //   web-     delete_record,
  //    JavaScript (.  university.js).  
  //    delete_exam    ""
  // (.  display_exams_list   progress_view.php).
  echo '{ "rows": "' . pg_affected_rows( $result ) . '" }';

  //  .
  pg_free_result( $result );

  //      .
  pg_close( $dbconn );
}

/*
       progress.
*/
function get_exam_info( $record_book, $acad_year, $term, $discipline_code )
{
  // : $record_book --   ;
  //            $acad_year --  ;
  //            $term -- ;
  //            $discipline_code --   .
  
  $dbconn = pg_connect( CONNECTION_STRING ) or
    die( '     : ' . pg_last_error() );

  //     .
  $query = "SELECT p.record_book, p.acad_year, p.term, " .
                  "p.discipline_code, d.discipline_name, p.mark " .
           "FROM progress p JOIN disciplines d " .
                "ON p.discipline_code = d.discipline_code " .
           "WHERE p.record_book = $1 AND p.acad_year = $2 AND " .
                 "p.term = $3 AND p.discipline_code = $4";

  $result = pg_query_params( $dbconn, $query,
                             array( $record_book, $acad_year, $term, 
                                    $discipline_code )
                           );

  //  ,    PGSQL_TUPLES_OK,
  //   PGSQL_COMMAND_OK.
  if ( pg_result_status( $result ) != PGSQL_TUPLES_OK )
  {
    die ( ': ' . pg_last_error( $dbconn ) );
  }

  //     --    .
  $exam_info = pg_fetch_array( $result, NULL, PGSQL_ASSOC );
  
  pg_free_result( $result );
  pg_close( $dbconn );

  return $exam_info;
}

/*
       progress     
    .
*/
function get_exams_list( $record_book )
{
  // : $record_book --   .

  $exams_list = array();

  $dbconn = pg_connect( CONNECTION_STRING ) or
    die( '     : ' . pg_last_error() );

  $query = "SELECT p.record_book, p.acad_year, p.term, " .
                  "p.discipline_code, d.discipline_name, p.mark " .
           "FROM progress p JOIN disciplines d ON " .
                "p.discipline_code  = d.discipline_code " .
           "WHERE record_book = $1 " .
           "ORDER BY p.acad_year, p.term, d.discipline_name";

  $result = pg_query_params( $dbconn, $query, array( $record_book ) );

  //  ,     PGSQL_TUPLES_OK,
  //   PGSQL_COMMAND_OK.
  if ( pg_result_status( $result ) != PGSQL_TUPLES_OK )
  {
    die ( ': ' . pg_last_error( $dbconn ) );
  }

  //          .
  //  NULL ,      .
  //  PGSQL_ASSOC ,      
  //   - ( ).
  while ( $exam_info = pg_fetch_array( $result, NULL, PGSQL_ASSOC ) )
  {
    //   (  ) , 
    //        .
    //   ,  $exam_info --  
    //  ().
    $exams_list[] = $exam_info;
  }

  pg_free_result( $result );
  pg_close( $dbconn );

  return $exams_list;
}

/*
       progress.
*/
function insert_exam()
{
  //    .
  $dbconn = pg_connect( CONNECTION_STRING )
    or die( '     : ' . pg_last_error() );

  //  ,      
  // -: $1, $2  . .
  $query = "INSERT INTO progress " .
                  "( record_book, acad_year, term, discipline_code, mark ) " .
           "VALUES ( $1, $2, $3, $4, $5 )";

  //     .    
  //   .
  $result = pg_query_params( $dbconn, $query,
                             array( $_POST[ 'record_book' ],
                                    $_POST[ 'acad_year' ],
                                    $_POST[ 'term' ],
                                    $_POST[ 'discipline_code' ],
                                    $_POST[ 'mark' ] )
                           );

  //    .
  if ( pg_result_status( $result ) != PGSQL_COMMAND_OK )
  {
    die ( ': ' . pg_last_error( $dbconn ) );
  }

  //     (1  0).
  $num_rows = pg_affected_rows( $result );
  
  //  .
  pg_free_result( $result );

  //      .
  pg_close( $dbconn );

  return $num_rows;
}

/*
       progress.
*/
function update_exam()
{
  $dbconn = pg_connect( CONNECTION_STRING )
    or die( '     : ' . pg_last_error() );

  $query = "UPDATE progress " .
           "SET ( record_book, acad_year, term, discipline_code, mark ) = " .
           "( $1, $2, $3, $4, $5 ) " .
           "WHERE record_book = $6 AND acad_year = $7 AND " .
                 "term = $8 AND discipline_code = $9";

  $result = pg_query_params( $dbconn, $query,
                             array( $_POST[ 'record_book' ],
                                    $_POST[ 'acad_year' ],
                                    $_POST[ 'term' ],
                                    $_POST[ 'discipline_code' ],
                                    $_POST[ 'mark' ],
                                    $_POST[ 'current_record_book' ],
                                    $_POST[ 'current_acad_year' ],
                                    $_POST[ 'current_term' ],
                                    $_POST[ 'current_discipline_code' ]
                                  )
                           );

  if ( pg_result_status( $result ) != PGSQL_COMMAND_OK )
  {
    die ( ': ' . pg_last_error( $dbconn ) );
  }

  //     (1  0).
  $num_rows = pg_affected_rows( $result );

  pg_free_result( $result );
  pg_close( $dbconn );

  return $num_rows;
}

?>
