<?php
/*
  : "  "
  :      (    
            )
  :   . . 
  :    30.11.2017
  :  0.1
*/

//          
// .
define( "CONNECTION_STRING", "host=localhost dbname=edu user=postgres" );

//      ,  ,
//         .
// $log = fopen( 'log.txt', 'a' );
// fwrite( $log, "delete_student " . $record_book . "\n" );
// fclose( $log );

/*
       students.
*/
function delete_student( $record_book )
{
  //    .
  $dbconn = pg_connect( CONNECTION_STRING )
    or die( '     : ' . pg_last_error() );

  //  ,      
  // -: $1, $2  . .
  $query = "DELETE FROM students WHERE record_book = $1";

  //     .    
  //   .
  $result = pg_query_params( $dbconn, $query, array( $record_book ) );

  //    .
  if ( pg_result_status( $result ) != PGSQL_COMMAND_OK )
  {
    //        .  
    //  web-      delete_record
    // (.  university.js).
    echo pg_last_error( $dbconn );

    //      .
    pg_close( $dbconn );

    return;
  }

  //   JSON.   rows    
  //   (1  0).   JSON   .
  //   web-     delete_record,
  //    JavaScript (.  university.js).  
  //    delete_student    ""
  // (.  display_students_list   students_view.php).
  echo '{ "rows": "' . pg_affected_rows( $result ) . '" }';

  //  .
  pg_free_result( $result );

  //      .
  pg_close( $dbconn );
}

/*
       students.
*/
function get_student_info( $record_book )
{
  // : $record_book --   
  
  $dbconn = pg_connect( CONNECTION_STRING ) or
    die( '     : ' . pg_last_error() );

  //     .
  $query = "SELECT record_book, name, psp_ser, psp_num " .
           "FROM students WHERE record_book = $1";

  $result = pg_query_params( $dbconn, $query, array( $record_book ) );

  //  ,     PGSQL_TUPLES_OK,
  //   PGSQL_COMMAND_OK.
  if ( pg_result_status( $result ) != PGSQL_TUPLES_OK )
  {
    die ( ': ' . pg_last_error( $dbconn ) );
  }

  //     --    .
  $student_info = pg_fetch_array( $result, NULL, PGSQL_ASSOC );
  
  pg_free_result($result);
  pg_close( $dbconn );

  return $student_info;
}

/*
       students.
*/
function get_students_list()
{
  $students_list = array();

  $dbconn = pg_connect( CONNECTION_STRING ) or
    die( '     : ' . pg_last_error() );

  $query = 'SELECT record_book, name, psp_ser, psp_num ' .
           'FROM students ORDER BY name';

  //   WHERE   ,   pg_query.
  $result = pg_query( $dbconn, $query );

  //  ,     PGSQL_TUPLES_OK,
  //   PGSQL_COMMAND_OK.
  if ( pg_result_status( $result ) != PGSQL_TUPLES_OK )
  {
    die ( ': ' . pg_last_error( $dbconn ) );
  }

  //          .
  //  NULL ,      .
  //  PGSQL_ASSOC ,      
  //   - ( ).
  while ( $student_info = pg_fetch_array( $result, NULL, PGSQL_ASSOC ) )
  {
    //   (  ) , 
    //        .
    //   ,  $student_info --  
    //  ().
    $students_list[] = $student_info;
  }

  pg_free_result( $result );
  pg_close( $dbconn );

  return $students_list;
}

/*
       students.
*/
function insert_student()
{
  //    .
  $dbconn = pg_connect( CONNECTION_STRING )
    or die( '     : ' . pg_last_error() );

  //  ,      
  // -: $1, $2  . .
  $query = "INSERT INTO students ( record_book, name, psp_ser, psp_num ) " .
           "VALUES ( $1, $2, $3, $4 )";

  //     .    
  //   .
  $result = pg_query_params( $dbconn, $query,
                             array( $_POST[ 'record_book' ], $_POST[ 'name' ],
                                    $_POST[ 'psp_ser' ], $_POST[ 'psp_num' ] )
                           );

  //    .
  if ( pg_result_status( $result ) != PGSQL_COMMAND_OK )
  {
    die ( ': ' . pg_last_error( $dbconn ) );
  }

  //     (1  0).
  $num_rows = pg_affected_rows( $result );
  
  //  .
  pg_free_result( $result );

  //      .
  pg_close( $dbconn );

  return $num_rows;
}

/*
       students.
*/
function update_student()
{
  $dbconn = pg_connect( CONNECTION_STRING )
    or die( '     : ' . pg_last_error() );

  $query = "UPDATE students " .
           "SET ( record_book, name, psp_ser, psp_num ) = " .
           "( $1, $2, $3, $4 ) " .
           "WHERE record_book = $5";

  $result = pg_query_params( $dbconn, $query,
                             array( $_POST[ 'record_book' ], $_POST[ 'name' ],
                                    $_POST[ 'psp_ser' ], $_POST[ 'psp_num' ],
                                    $_POST[ 'current_record_book' ] )
                           );

  if ( pg_result_status( $result ) != PGSQL_COMMAND_OK )
  {
    die ( ': ' . pg_last_error( $dbconn ) );
  }

  //     (1  0).
  $num_rows = pg_affected_rows( $result );

  pg_free_result( $result );
  pg_close($dbconn);

  return $num_rows;
}

?>
