/*
  Система: "Учет успеваемости студентов"
  Модуль:  функции на языке JavaScript, используемые в модуле 
           "Учебные дисциплины"
  Автор:   Е. П. Моргунов
  Дата:    30.11.2017
  Версия:  0.1
*/

/*
  Копирование значений полей из модуля "Учебные дисциплины" в поля формы
  ввода (корректировки) данных в модуле "Экзаменационные оценки".
*/
function assign_values( disc_code, disc_name )
{
  // Параметры: disc_code -- код учебной дисциплины;
  //            disc_name -- наименование учебной дисциплины.

  // Присвоим значения кода дисциплины и ее наименования
  // полям в ВЫЗЫВАЮЩЕМ окне (т. е. в форме для ввода/корректировки
  // экзаменационной оценки). Затем сделаем поле discipline_code
  // активным и закроем окно со списком дисциплин.
  // ПРИМЕЧАНИЕ. Можно обратиться к полям формы таким образом:
  //             forms -- это массив, содержащий все формы данного документа
  //             (если форма всего одна, как в нашем случае, то доступ
  //             к ней получим так -- forms[ 0 ]; 
  //             discipline_code -- это имя поля, созданного в форме
  //             forms[ 0 ];
  //             value -- значение этого поля.
  opener.document.forms[ 0 ].discipline_code.value = disc_code;
  opener.document.forms[ 0 ].discipline_name.value = disc_name;

  // Сделаем это поле активным.
  opener.document.forms[ 0 ].discipline_code.focus();
  close();
}
  
/*
  Проверка значений, введенных в поля формы.
*/
function check_discipline_form()
{
  // Абзац (параграф), в который будут записываться сообщения об ошибках
  // при вводе значений.
  var err = document.getElementById( "error" );

  // Доступ к значениям полей формы можно получить по идентификатору
  // этой формы и идентификаторам ее полей.
  var d_code = document.forms[ "discipline_form" ][ "d_code" ];
  var d_name = document.forms[ "discipline_form" ][ "d_name" ];

  var ckeck_ok = true;

  // Запишем пустую строку в этот абзац.
  err.innerHTML = "";

  // Сделаем проверки только на предмет отсутствия введенных значений.
  if ( d_code.value == "" )
  {
    err.innerHTML += "Поле 'Код учебной дисциплины' не заполнено<br />";
    ckeck_ok = false;
  }
    
  if ( d_name.value == "" )
  {
    err.innerHTML +=
      "Поле 'Наименование учебной дисциплины' не заполнено<br />";
    ckeck_ok = false;
  }

  return ckeck_ok;
}

/*
  Удаление записи из таблицы disciplines.
*/
function delete_discipline( script_name, discipline_code, row )
{
  // Параметры: script_name -- имя скрипта, вызвавшего эту функцию;
  //            dscipline_code -- код учебной дисциплины;
  //            row -- идентификатор строки в таблице оценок на экране.

  var script_params;
    
  // Строка-параметр содержит код учебной дисциплины для той записи,
  // которую нужно удалить.
  script_params = "discipline_code=" + discipline_code;

  // Вызываем функцию, которая выполнит обращение к web-серверу.
  delete_record( script_name, script_params, row );
}
