<?php
/*
  Система: "Учет успеваемости студентов"
  Модуль:  главный модуль справочника учебных дисциплин
  Автор:   Е. П. Моргунов
  Дата:    30.11.2017
  Версия:  0.1
*/

// Включаемые файлы содержат тексты функций, которые могут быть вызваны
// из этого файла. 
include 'disciplines_db.php';
include 'disciplines_view.php';

// Поместив подобную конструкцию в каждую процедуру, можно выяснить,
// какие процедуры работают при выполнении того или иного запроса.
// $log = fopen( 'log.txt', 'a' );
// fwrite( $log, "disciplines.php\n" );
// fclose( $log );

// В глобальном массиве $_POST содержатся значения полей, переданных скрипту
// методом POST.

// Если была нажата кнопка с именем 'add_discipline' ...
// Функция isset проверяет существование указанной переменной или
// элемента массива.
if ( isset( $_POST[ 'add_discipline' ] ) )
{
  $rec_num = insert_discipline();      // Добавим запись в таблицу disciplines.
  inform_inserted_discipline( $rec_num ); // Выведем сообщение об этом.
  exit( 0 );
}
// Если была нажата кнопка с именем 'update_discipline' ...
elseif ( isset( $_POST[ 'update_discipline' ] ) )
{
  $rec_num = update_discipline();      // Обновим запись в таблице disciplines.
  inform_updated_discipline( $rec_num );  // Выведем сообщение об этом.
  exit( 0 );
}

// В глобальном массиве $_GET содержатся значения полей, переданных скрипту
// методом GET.

// Если была выбрана операция добавления новой записи ...
if ( isset( $_GET[ 'operation' ] ) && $_GET[ 'operation' ] == 'insert' )
{
  display_discipline_form( NULL );  // Выведем на экран форму с пустыми полями.
}
// Если была выбрана операция обновления записи ...
elseif ( isset( $_GET[ 'operation' ] ) && $_GET[ 'operation' ] == 'update' &&
         isset( $_GET[ 'discipline_code' ] ) )
{
  // Получим из таблицы disciplines сведения для конкретной дисциплины.
  $discipline_info = get_discipline_info( $_GET[ 'discipline_code' ] );
  // Выведем на экран форму с полями, содержащими значения полученной
  // записи из таблицы.
  display_discipline_form( $discipline_info );
}
// Если была выбрана операция удаления записи ...
elseif ( isset( $_POST[ 'operation' ] ) && $_POST[ 'operation' ] == 'delete' )
{
  // Удалим из таблицы disciplines сведения о конкретной дисциплине.
  $rec_num = delete_discipline( $_POST[ 'discipline_code' ] );
}
// Если этот модуль был вызван для выбора учебной дисциплины из списка
// при выполнении добавления новой записи или корректировки текущей записи
// об экзамене...
elseif ( isset( $_GET[ 'operation' ] ) && $_GET[ 'operation' ] == 'select' )
{
  $disciplines = get_disciplines_list();       // Получим выборку из таблицы.
  display_disciplines_list( $disciplines, 1 ); // Выведем ее на экран.
}
// Выберем все записи из таблицы disciplines.
else
{
  $disciplines = get_disciplines_list();          // Получим выборку из таблицы.
  display_disciplines_list( $disciplines, NULL ); // Выведем ее на экран.
}

?>
