/*
  Система: "Учет успеваемости студентов"
  Модуль:  функции на языке JavaScript, используемые в модуле 
           "Экзаменационные оценки"
  Автор:   Е. П. Моргунов
  Дата:    30.11.2017
  Версия:  0.1
*/
  
/*
  Проверка значений, введенных в поля формы.
*/
function check_exam_form()
{
  // Абзац (параграф), в который будут записываться сообщения об ошибках
  // при вводе значений.
  var err = document.getElementById( "error" );

  // Доступ к значениям полей формы можно получить по идентификатору
  // этой формы и идентификаторам ее полей.
  var r_book = document.forms[ "exam_form" ][ "a_year" ];
  var f_name = document.forms[ "exam_form" ][ "term" ];
  var p_ser  = document.forms[ "exam_form" ][ "d_code" ];
  var p_num  = document.forms[ "exam_form" ][ "mark" ];

  var ckeck_ok = true;

  // Запишем пустую строку в этот абзац.
  err.innerHTML = "";

  // Сделаем проверки только на предмет отсутствия введенных значений.
  if ( a_year.value == "" )
  {
    err.innerHTML += "Поле 'Учебный год' не заполнено<br />";
    ckeck_ok = false;
  }
    
  if ( term.value == "" )
  {
    err.innerHTML += "Поле 'Семестр' не заполнено<br />";
    ckeck_ok = false;
  }

  if ( d_code.value == "" )
  {
    err.innerHTML += "Поле 'Код учебной дисциплины' не заполнено<br />";
    ckeck_ok = false;
  }

  if ( mark.value == "" )
  {
    err.innerHTML += "Поле 'Оценка' не заполнено<br />";
    ckeck_ok = false;
  }

  return ckeck_ok;
}

/*
  Удаление записи из таблицы students.
*/
function delete_exam( script_name, record_book, acad_year, term,
                      discipline_code, row )
{
  // Параметры: script_name -- имя скрипта, вызвавшего эту функцию;
  //            record_book -- номер зачетной книжки;
  //            aad_year -- учебный год;
  //            term -- семестр;
  //            dscipline_code -- код учебной дисциплины;
  //            row -- идентификатор строки в таблице оценок на экране.
  
  var script_params;
    
  // Строка-параметр содержит имена и значения полей для той записи,
  // которую нужно удалить.
  script_params = "record_book=" + record_book +
                  "&acad_year=" + acad_year + "&term=" + term + 
                  "&discipline_code=" + discipline_code;

  // Вызываем функцию, которая выполнит обращение к web-серверу.
  delete_record( script_name, script_params, row );
}

/*
  Вызов модуля "Учебные дисциплины" для выбора дисциплины при вводе или
  корректировке записи об экзамене.
*/
function select_discipline()
{
  window.open( 'disciplines.php?operation=select',
               'disciplines',
               'width=900, height=500, status=yes' );
}
