<?php
/*
  Система: "Учет успеваемости студентов"
  Модуль:  главный модуль "Экзаменационные оценки"
  Автор:   Е. П. Моргунов
  Дата:    30.11.2017
  Версия:  0.1
*/

include 'progress_db.php';
include 'progress_view.php';

// Поместив подобную конструкцию в каждую процедуру, можно выяснить,
// какие процедуры работают при выполнении того или иного запроса.
// $log = fopen( 'log.txt', 'a' );
// fwrite( $log, "progress.php\n" );
// fclose( $log );

// В глобальном массиве $_POST содержатся значения полей, переданных скрипту
// методом POST.

// Если была нажата кнопка с именем 'add_exam' ...
// Функция isset проверяет существование указанной переменной или
// элемента массива.
if ( isset( $_POST[ 'add_exam' ] ) )
{
  $rec_num = insert_exam();         // Добавим запись в таблицу progress.
  inform_inserted_exam( $rec_num ); // Выведем сообщение об этом.
  exit( 0 );
}
// Если была нажата кнопка с именем 'update_exam' ...
elseif ( isset( $_POST[ 'update_exam' ] ) )
{
  $rec_num = update_exam();         // Обновим запись в таблице progress.
  inform_updated_exam( $rec_num );  // Выведем сообщение об этом.
  exit( 0 );
}

// В глобальном массиве $_GET содержатся значения полей, переданных скрипту
// методом GET.

// Если была выбрана операция добавления новой записи ...
if ( isset( $_GET[ 'operation' ] ) && $_GET[ 'operation' ] == 'insert' &&
     isset( $_GET[ 'record_book' ] ) )
{
  // Выведем на экран форму с пустыми полями.
  display_exam_form( $_GET[ 'record_book' ], $_GET[ 'name' ], NULL );
}
// Если была выбрана операция обновления записи ...
elseif ( isset( $_GET[ 'operation' ] ) && $_GET[ 'operation' ] == 'update' &&
         isset( $_GET[ 'record_book' ] ) && isset( $_GET[ 'acad_year' ] ) && 
         isset( $_GET[ 'term' ] ) && isset( $_GET[ 'discipline_code' ] )
       )
{
  // Получим из таблицы progress сведения для конкретного экзамена
  // конкретного студента.
  $exam_info = get_exam_info( $_GET[ 'record_book' ],
                              $_GET[ 'acad_year' ],
                              $_GET[ 'term' ],
                              $_GET[ 'discipline_code' ]
                            );
  // Выведем на экран форму с полями, содержащими значения полученной
  // записи из таблицы.
  display_exam_form( $_GET[ 'record_book' ], $_GET[ 'name' ], $exam_info );
}
// Если была выбрана операция удаления записи ...
elseif ( isset( $_POST[ 'operation' ] ) && $_POST[ 'operation' ] == 'delete' )
{
  // Удалим из таблицы progress сведения о конкретном экзамене 
  // указанного студента.
  $rec_num = delete_exam( $_POST[ 'record_book' ], 
                          $_POST[ 'acad_year' ],
                          $_POST[ 'term' ],
                          $_POST[ 'discipline_code' ] );
}
// Выберем все записи из таблицы progress для студента с указанным
// номером зачетной книжки.
else
{
  // Получим выборку из таблицы progress.
  $exams = get_exams_list( $_GET[ 'record_book' ] );
  // Выведем ее на экран.
  display_exams_list( $_GET[ 'record_book' ], $_GET[ 'name' ], $exams );
}

?>
