/*
  Система: "Учет успеваемости студентов"
  Модуль:  функции на языке JavaScript, используемые в модуле "Студенты"
  Автор:   Е. П. Моргунов
  Дата:    30.11.2017
  Версия:  0.1
*/

/*
  Проверка значений, введенных в поля формы.
*/
function check_student_form()
{
  // Абзац (параграф), в который будут записываться сообщения об ошибках
  // при вводе значений.
  var err = document.getElementById( "error" );

  // Доступ у значениям полей формы можно получить по идентификатору
  // этой формы и идентификаторам ее полей.
  var r_book = document.forms[ "student_form" ][ "r_book" ];
  var f_name = document.forms[ "student_form" ][ "f_name" ];
  var p_ser  = document.forms[ "student_form" ][ "p_ser" ];
  var p_num  = document.forms[ "student_form" ][ "p_num" ];

  var ckeck_ok = true;

  // Запишем пустую строку в этот абзац.
  err.innerHTML = "";

  // Сделаем проверки только на предмет отсутствия введенных значений.
  if ( r_book.value == "" )
  {
    err.innerHTML += "Поле 'Номер зачетной книжки' не заполнено<br />";
    ckeck_ok = false;
  }
    
  if ( f_name.value == "" )
  {
    err.innerHTML += "Поле 'Ф. И. О.' не заполнено<br />";
    ckeck_ok = false;
  }

  if ( p_ser.value == "" )
  {
    err.innerHTML += "Поле 'Серия паспорта' не заполнено<br />";
    ckeck_ok = false;
  }

  if ( p_num.value == "" )
  {
    err.innerHTML += "Поле 'Номер паспорта' не заполнено<br />";
    ckeck_ok = false;
  }

  return ckeck_ok;
}

/*
  Удаление записи из таблицы students.
*/
function delete_student( script_name, record_book, row )
{
  // Параметры: script_name -- имя скрипта, вызвавшего эту функцию;
  //            record_book -- номер зачетной книжки;
  //            row -- идентификатор строки в таблице студентов на экране.

  var script_params;
    
  // Строка-параметр содержит номер зачетной книжки для той записи,
  // которую нужно удалить.
  script_params = "record_book=" + record_book;

  // Вызываем функцию, которая выполнит обращение к web-серверу.
  delete_record( script_name, script_params, row );
}
