<?php
/*
  Система: "Учет успеваемости студентов"
  Модуль:  главный модуль для работы с информацией о студентах
  Автор:   Е. П. Моргунов
  Дата:    30.11.2017
  Версия:  0.1
*/

// Включаемые файлы содержат тексты функций, которые могут быть вызваны
// из этого файла.
include 'students_db.php';
include 'students_view.php';

// Поместив подобную конструкцию в каждую процедуру, можно выяснить,
// какие процедуры работают при выполнении того или иного запроса.
// $log = fopen( 'log.txt', 'a' );
// fwrite( $log, "students.php\n" );
// fclose( $log );

// В глобальном массиве $_POST содержатся значения полей, переданных скрипту
// методом POST.

// Если была нажата кнопка с именем 'add_student' ...
// Функция isset проверяет существование указанной переменной или
// элемента массива.
if ( isset( $_POST[ 'add_student' ] ) )
{
  $rec_num = insert_student();         // Добавим запись в таблицу students.
  inform_inserted_student( $rec_num ); // Выведем сообщение об этом.
  exit( 0 );
}
// Если была нажата кнопка с именем 'update_student' ...
elseif ( isset( $_POST[ 'update_student' ] ) )
{
  $rec_num = update_student();         // Обновим запись в таблице students.
  inform_updated_student( $rec_num );  // Выведем сообщение об этом.
  exit( 0 );
}

// В глобальном массиве $_GET содержатся значения полей, переданных скрипту
// методом GET.

// Если была выбрана операция добавления новой записи ...
if ( isset( $_GET[ 'operation' ] ) && $_GET[ 'operation' ] == 'insert' )
{
  display_student_form( NULL );  // Выведем на экран форму с пустыми полями.
}
// Если была выбрана операция обновления записи ...
elseif ( isset( $_GET[ 'operation' ] ) && $_GET[ 'operation' ] == 'update' &&
         isset( $_GET[ 'record_book' ] ) )
{
  // Получим из таблицы students сведения для конкретного студента.
  $student_info = get_student_info( $_GET[ 'record_book' ] );
  // Выведем на экран форму с полями, содержащими значения полученной
  // записи из таблицы.
  display_student_form( $student_info );
}
// Если была выбрана операция удаления записи ...
elseif ( isset( $_POST[ 'operation' ] ) && $_POST[ 'operation' ] == 'delete' )
{
  // Удалим из таблицы students сведения о конкретном студенте.
  $rec_num = delete_student( $_POST[ 'record_book' ] );
}
// Выберем все записи из таблицы students.
else
{
  $students = get_students_list();    // Получим выборку из таблицы.
  display_students_list( $students ); // Выведем ее на экран.
}

?>
